Index: uspace/srv/audio/hound/audio_device.c
===================================================================
--- uspace/srv/audio/hound/audio_device.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/audio_device.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,10 +51,10 @@
 #define BUFFER_PARTS   16
 
-static errno_t device_sink_connection_callback(audio_sink_t *sink, bool new);
-static errno_t device_source_connection_callback(audio_source_t *source, bool new);
+static int device_sink_connection_callback(audio_sink_t *sink, bool new);
+static int device_source_connection_callback(audio_source_t *source, bool new);
 static void device_event_callback(ipc_callid_t iid, ipc_call_t *icall, void *arg);
-static errno_t device_check_format(audio_sink_t* sink);
-static errno_t get_buffer(audio_device_t *dev);
-static errno_t release_buffer(audio_device_t *dev);
+static int device_check_format(audio_sink_t* sink);
+static int get_buffer(audio_device_t *dev);
+static int release_buffer(audio_device_t *dev);
 static void advance_buffer(audio_device_t *dev, size_t size);
 static inline bool is_running(audio_device_t *dev)
@@ -62,5 +62,5 @@
 	assert(dev);
 	/* we release buffer on stop so this should be enough */
-	return dev->buffer.base != NULL;
+	return (bool)dev->buffer.base;
 }
 
@@ -72,5 +72,5 @@
  * @return Error code.
  */
-errno_t audio_device_init(audio_device_t *dev, service_id_t id, const char *name)
+int audio_device_init(audio_device_t *dev, service_id_t id, const char *name)
 {
 	assert(dev);
@@ -121,7 +121,5 @@
 {
 	assert(dev);
-	sysarg_t val;
-	errno_t rc = audio_pcm_query_cap(dev->sess, AUDIO_CAP_CAPTURE, &val);
-	if (rc == EOK && val)
+	if (audio_pcm_query_cap(dev->sess, AUDIO_CAP_CAPTURE))
 		return &dev->source;
 	return NULL;
@@ -137,7 +135,5 @@
 {
 	assert(dev);
-	sysarg_t val;
-	errno_t rc = audio_pcm_query_cap(dev->sess, AUDIO_CAP_PLAYBACK, &val);
-	if (rc == EOK && val)
+	if (audio_pcm_query_cap(dev->sess, AUDIO_CAP_PLAYBACK))
 		return &dev->sink;
 	return NULL;
@@ -153,5 +149,5 @@
  * connections.
  */
-static errno_t device_sink_connection_callback(audio_sink_t* sink, bool new)
+static int device_sink_connection_callback(audio_sink_t* sink, bool new)
 {
 	assert(sink);
@@ -160,5 +156,5 @@
 		log_verbose("First connection on device sink '%s'", sink->name);
 
-		errno_t ret = get_buffer(dev);
+		int ret = get_buffer(dev);
 		if (ret != EOK) {
 			log_error("Failed to get device buffer: %s",
@@ -196,5 +192,5 @@
 		log_verbose("Removed last connection on device sink '%s'",
 		    sink->name);
-		errno_t ret = audio_pcm_stop_playback(dev->sess);
+		int ret = audio_pcm_stop_playback(dev->sess);
 		if (ret != EOK) {
 			log_error("Failed to stop playback: %s",
@@ -215,10 +211,10 @@
  * connections.
  */
-static errno_t device_source_connection_callback(audio_source_t *source, bool new)
+static int device_source_connection_callback(audio_source_t *source, bool new)
 {
 	assert(source);
 	audio_device_t *dev = source->private_data;
 	if (new && list_count(&source->connections) == 1) {
-		errno_t ret = get_buffer(dev);
+		int ret = get_buffer(dev);
 		if (ret != EOK) {
 			log_error("Failed to get device buffer: %s",
@@ -244,5 +240,5 @@
 	if (list_count(&source->connections) == 0) { /* Disconnected */
 		assert(!new);
-		errno_t ret = audio_pcm_stop_capture_immediate(dev->sess);
+		int ret = audio_pcm_stop_capture_immediate(dev->sess);
 		if (ret != EOK) {
 			log_error("Failed to start recording: %s",
@@ -289,5 +285,5 @@
 			log_verbose("Capture terminated");
 			dev->source.format = AUDIO_FORMAT_ANY;
-			const errno_t ret = release_buffer(dev);
+			const int ret = release_buffer(dev);
 			if (ret != EOK) {
 				log_error("Failed to release buffer: %s",
@@ -300,5 +296,5 @@
 			log_verbose("Playback Terminated");
 			dev->sink.format = AUDIO_FORMAT_ANY;
-			const errno_t ret = release_buffer(dev);
+			const int ret = release_buffer(dev);
 			if (ret != EOK) {
 				log_error("Failed to release buffer: %s",
@@ -309,5 +305,5 @@
 		}
 		case PCM_EVENT_FRAMES_CAPTURED: {
-			const errno_t ret = audio_source_push_data(&dev->source,
+			const int ret = audio_source_push_data(&dev->source,
 			    dev->buffer.position, dev->buffer.fragment_size);
 			advance_buffer(dev, dev->buffer.fragment_size);
@@ -329,5 +325,5 @@
  * @return Error code.
  */
-static errno_t device_check_format(audio_sink_t* sink)
+static int device_check_format(audio_sink_t* sink)
 {
 	assert(sink);
@@ -347,5 +343,5 @@
  * @return Error code.
  */
-static errno_t get_buffer(audio_device_t *dev)
+static int get_buffer(audio_device_t *dev)
 {
 	assert(dev);
@@ -362,5 +358,5 @@
 	size_t preferred_size = 0;
 
-	const errno_t ret = audio_pcm_get_buffer(dev->sess, &dev->buffer.base,
+	const int ret = audio_pcm_get_buffer(dev->sess, &dev->buffer.base,
 	    &preferred_size);
 	if (ret == EOK) {
@@ -378,10 +374,10 @@
  * @return Error code.
  */
-static errno_t release_buffer(audio_device_t *dev)
+static int release_buffer(audio_device_t *dev)
 {
 	assert(dev);
 	assert(dev->buffer.base);
 
-	const errno_t ret = audio_pcm_release_buffer(dev->sess);
+	const int ret = audio_pcm_release_buffer(dev->sess);
 	if (ret == EOK) {
 		as_area_destroy(dev->buffer.base);
Index: uspace/srv/audio/hound/audio_device.h
===================================================================
--- uspace/srv/audio/hound/audio_device.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/audio_device.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -76,10 +76,10 @@
 };
 
-errno_t audio_device_init(audio_device_t *dev, service_id_t id, const char *name);
+int audio_device_init(audio_device_t *dev, service_id_t id, const char *name);
 void audio_device_fini(audio_device_t *dev);
 audio_source_t * audio_device_get_source(audio_device_t *dev);
 audio_sink_t * audio_device_get_sink(audio_device_t *dev);
-errno_t audio_device_recorded_data(audio_device_t *dev, void **base, size_t *size);
-errno_t audio_device_available_buffer(audio_device_t *dev, void **base, size_t *size);
+int audio_device_recorded_data(audio_device_t *dev, void **base, size_t *size);
+int audio_device_available_buffer(audio_device_t *dev, void **base, size_t *size);
 
 #endif
Index: uspace/srv/audio/hound/audio_sink.c
===================================================================
--- uspace/srv/audio/hound/audio_sink.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/audio_sink.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,7 +56,7 @@
  * @return Error code.
  */
-errno_t audio_sink_init(audio_sink_t *sink, const char *name, void *private_data,
-    errno_t (*connection_change)(audio_sink_t *, bool),
-    errno_t (*check_format)(audio_sink_t *), errno_t (*data_available)(audio_sink_t *),
+int audio_sink_init(audio_sink_t *sink, const char *name, void *private_data,
+    int (*connection_change)(audio_sink_t *, bool),
+    int (*check_format)(audio_sink_t *), int (*data_available)(audio_sink_t *),
     const pcm_format_t *f)
 {
@@ -97,5 +97,5 @@
  * @return Error code.
  */
-errno_t audio_sink_set_format(audio_sink_t *sink, const pcm_format_t *format)
+int audio_sink_set_format(audio_sink_t *sink, const pcm_format_t *format)
 {
 	assert(sink);
@@ -114,5 +114,5 @@
 	}
 	if (sink->check_format) {
-		const errno_t ret = sink->check_format(sink);
+		const int ret = sink->check_format(sink);
 		if (ret != EOK && ret != ELIMIT) {
 			log_debug("Format check failed on sink %s", sink->name);
@@ -141,5 +141,5 @@
 	pcm_format_silence(dest, size, &sink->format);
 	list_foreach(sink->connections, sink_link, connection_t, conn) {
-		const errno_t ret = connection_add_source_data(
+		const int ret = connection_add_source_data(
 		    conn, dest, size, sink->format);
 		if (ret != EOK) {
Index: uspace/srv/audio/hound/audio_sink.h
===================================================================
--- uspace/srv/audio/hound/audio_sink.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/audio_sink.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -54,5 +54,5 @@
 	list_t connections;
 	/** Sink's name */
-	char *name;
+	const char *name;
 	/** Consumes data in this format */
 	pcm_format_t format;
@@ -60,9 +60,9 @@
 	void *private_data;
 	/** Connect/disconnect callback */
-	errno_t (*connection_change)(audio_sink_t *, bool);
+	int (*connection_change)(audio_sink_t *, bool);
 	/** Backend callback to check data */
-	errno_t (*check_format)(audio_sink_t *);
+	int (*check_format)(audio_sink_t *);
 	/** new data notifier */
-	errno_t (*data_available)(audio_sink_t *);
+	int (*data_available)(audio_sink_t *);
 };
 
@@ -77,11 +77,11 @@
 }
 
-errno_t audio_sink_init(audio_sink_t *sink, const char *name, void *private_data,
-    errno_t (*connection_change)(audio_sink_t *, bool),
-    errno_t (*check_format)(audio_sink_t *), errno_t (*data_available)(audio_sink_t *),
+int audio_sink_init(audio_sink_t *sink, const char *name, void *private_data,
+    int (*connection_change)(audio_sink_t *, bool),
+    int (*check_format)(audio_sink_t *), int (*data_available)(audio_sink_t *),
     const pcm_format_t *f);
 
 void audio_sink_fini(audio_sink_t *sink);
-errno_t audio_sink_set_format(audio_sink_t *sink, const pcm_format_t *format);
+int audio_sink_set_format(audio_sink_t *sink, const pcm_format_t *format);
 void audio_sink_mix_inputs(audio_sink_t *sink, void* dest, size_t size);
 
Index: uspace/srv/audio/hound/audio_source.c
===================================================================
--- uspace/srv/audio/hound/audio_source.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/audio_source.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,7 +56,7 @@
  * @return Error code.
  */
-errno_t audio_source_init(audio_source_t *source, const char *name, void *data,
-    errno_t (*connection_change)(audio_source_t *, bool new),
-    errno_t (*update_available_data)(audio_source_t *, size_t),
+int audio_source_init(audio_source_t *source, const char *name, void *data,
+    int (*connection_change)(audio_source_t *, bool new),
+    int (*update_available_data)(audio_source_t *, size_t),
     const pcm_format_t *f)
 {
@@ -96,5 +96,5 @@
  * @return Error code.
  */
-errno_t audio_source_push_data(audio_source_t *source, void *data,
+int audio_source_push_data(audio_source_t *source, const void *data,
     size_t size)
 {
@@ -107,5 +107,5 @@
 
 	list_foreach(source->connections, source_link, connection_t, conn) {
-		const errno_t ret = connection_push_data(conn, adata);
+		const int ret = connection_push_data(conn, adata);
 		if (ret != EOK) {
 			log_warning("Failed push data to %s: %s",
Index: uspace/srv/audio/hound/audio_source.h
===================================================================
--- uspace/srv/audio/hound/audio_source.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/audio_source.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,5 @@
 	list_t connections;
 	/** String identifier */
-	char *name;
+	const char *name;
 	/** audio data format */
 	pcm_format_t format;
@@ -55,7 +55,7 @@
 	void *private_data;
 	/** Callback for connection and disconnection */
-	errno_t (*connection_change)(audio_source_t *source, bool added);
+	int (*connection_change)(audio_source_t *source, bool added);
 	/** Ask backend for more data */
-	errno_t (*update_available_data)(audio_source_t *source, size_t size);
+	int (*update_available_data)(audio_source_t *source, size_t size);
 };
 
@@ -70,10 +70,10 @@
 }
 
-errno_t audio_source_init(audio_source_t *source, const char *name, void *data,
-    errno_t (*connection_change)(audio_source_t *, bool),
-    errno_t (*update_available_data)(audio_source_t *, size_t),
+int audio_source_init(audio_source_t *source, const char *name, void *data,
+    int (*connection_change)(audio_source_t *, bool),
+    int (*update_available_data)(audio_source_t *, size_t),
     const pcm_format_t *f);
 void audio_source_fini(audio_source_t *source);
-errno_t audio_source_push_data(audio_source_t *source, void *data,
+int audio_source_push_data(audio_source_t *source, const void *data,
     size_t size);
 static inline const pcm_format_t *audio_source_format(const audio_source_t *s)
Index: uspace/srv/audio/hound/connection.c
===================================================================
--- uspace/srv/audio/hound/connection.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/connection.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -101,5 +101,5 @@
  * @param format format of the destination audio buffer.
  */
-errno_t connection_add_source_data(connection_t *connection, void *data,
+ssize_t connection_add_source_data(connection_t *connection, void *data,
     size_t size, pcm_format_t format)
 {
@@ -116,10 +116,10 @@
 	log_verbose("Data available after update: %zu",
 	    audio_pipe_bytes(&connection->fifo));
-	size_t ret =
+	ssize_t ret =
 	    audio_pipe_mix_data(&connection->fifo, data, size, &format);
-	if (ret != size)
+	if (ret != (ssize_t)size)
 		log_warning("Connection failed to provide enough data %zd/%zu",
 		    ret, size);
-	return EOK;
+	return ret > 0 ? EOK : ret;
 }
 /**
@@ -129,10 +129,10 @@
  * @return Error code.
  */
-errno_t connection_push_data(connection_t *connection,
+int connection_push_data(connection_t *connection,
     audio_data_t *adata)
 {
 	assert(connection);
 	assert(adata);
-	const errno_t ret = audio_pipe_push(&connection->fifo, adata);
+	const int ret = audio_pipe_push(&connection->fifo, adata);
 	if (ret == EOK && connection->sink->data_available)
 		connection->sink->data_available(connection->sink);
Index: uspace/srv/audio/hound/connection.h
===================================================================
--- uspace/srv/audio/hound/connection.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/connection.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -84,8 +84,8 @@
 void connection_destroy(connection_t *connection);
 
-errno_t connection_add_source_data(connection_t *connection, void *data,
+ssize_t connection_add_source_data(connection_t *connection, void *data,
     size_t size, pcm_format_t format);
 
-errno_t connection_push_data(connection_t *connection, audio_data_t *adata);
+int connection_push_data(connection_t *connection, audio_data_t *adata);
 
 /**
Index: uspace/srv/audio/hound/hound.c
===================================================================
--- uspace/srv/audio/hound/hound.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/hound.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 #include <assert.h>
 #include <stdlib.h>
-#include <str.h>
 
 #include "hound.h"
@@ -111,5 +110,5 @@
 }
 
-static errno_t hound_disconnect_internal(hound_t *hound, const char* source_name, const char* sink_name);
+static int hound_disconnect_internal(hound_t *hound, const char* source_name, const char* sink_name);
 
 /**
@@ -163,5 +162,5 @@
  * @return Error code.
  */
-errno_t hound_init(hound_t *hound)
+int hound_init(hound_t *hound)
 {
 	assert(hound);
@@ -181,5 +180,5 @@
  * @return Error code.
  */
-errno_t hound_add_ctx(hound_t *hound, hound_ctx_t *ctx)
+int hound_add_ctx(hound_t *hound, hound_ctx_t *ctx)
 {
 	log_info("Trying to add context %p", ctx);
@@ -190,5 +189,5 @@
 	list_append(&ctx->link, &hound->contexts);
 	fibril_mutex_unlock(&hound->list_guard);
-	errno_t ret = EOK;
+	int ret = EOK;
 	if (ret == EOK && ctx->source)
 		ret = hound_add_source(hound, ctx->source);
@@ -209,5 +208,5 @@
  * @return Error code.
  */
-errno_t hound_remove_ctx(hound_t *hound, hound_ctx_t *ctx)
+int hound_remove_ctx(hound_t *hound, hound_ctx_t *ctx)
 {
 	assert(hound);
@@ -255,5 +254,5 @@
  * @return Error code.
  */
-errno_t hound_add_device(hound_t *hound, service_id_t id, const char *name)
+int hound_add_device(hound_t *hound, service_id_t id, const char *name)
 {
 	log_verbose("Adding device \"%s\", service: %zu", name, id);
@@ -284,5 +283,5 @@
 	}
 
-	const errno_t ret = audio_device_init(dev, id, name);
+	const int ret = audio_device_init(dev, id, name);
 	if (ret != EOK) {
 		log_debug("Failed to initialize new audio device: %s",
@@ -297,5 +296,5 @@
 	audio_source_t *source = audio_device_get_source(dev);
 	if (source) {
-		const errno_t ret = hound_add_source(hound, source);
+		const int ret = hound_add_source(hound, source);
 		if (ret != EOK) {
 			log_debug("Failed to add device source: %s",
@@ -309,5 +308,5 @@
 	audio_sink_t *sink = audio_device_get_sink(dev);
 	if (sink) {
-		const errno_t ret = hound_add_sink(hound, sink);
+		const int ret = hound_add_sink(hound, sink);
 		if (ret != EOK) {
 			log_debug("Failed to add device sink: %s",
@@ -331,5 +330,5 @@
  * @return Error code.
  */
-errno_t hound_add_source(hound_t *hound, audio_source_t *source)
+int hound_add_source(hound_t *hound, audio_source_t *source)
 {
 	assert(hound);
@@ -355,5 +354,5 @@
  * @return Error code.
  */
-errno_t hound_add_sink(hound_t *hound, audio_sink_t *sink)
+int hound_add_sink(hound_t *hound, audio_sink_t *sink)
 {
 	assert(hound);
@@ -379,5 +378,5 @@
  * @return Error code.
  */
-errno_t hound_remove_source(hound_t *hound, audio_source_t *source)
+int hound_remove_source(hound_t *hound, audio_source_t *source)
 {
 	assert(hound);
@@ -396,5 +395,5 @@
  * @return Error code.
  */
-errno_t hound_remove_sink(hound_t *hound, audio_sink_t *sink)
+int hound_remove_sink(hound_t *hound, audio_sink_t *sink)
 {
 	assert(hound);
@@ -414,5 +413,5 @@
  * @return Error code.
  */
-errno_t hound_list_sources(hound_t *hound, char ***list, size_t *size)
+int hound_list_sources(hound_t *hound, const char ***list, size_t *size)
 {
 	assert(hound);
@@ -428,6 +427,6 @@
 		return EOK;
 	}
-	char **names = calloc(count, sizeof(char *));
-	errno_t ret = names ? EOK : ENOMEM;
+	const char **names = calloc(count, sizeof(char *));
+	int ret = names ? EOK : ENOMEM;
 	for (unsigned long i = 0; i < count && ret == EOK; ++i) {
 		link_t *slink = list_nth(&hound->sources, i);
@@ -456,5 +455,5 @@
  * @return Error code.
  */
-errno_t hound_list_sinks(hound_t *hound, char ***list, size_t *size)
+int hound_list_sinks(hound_t *hound, const char ***list, size_t *size)
 {
 	assert(hound);
@@ -470,6 +469,6 @@
 		return EOK;
 	}
-	char **names = calloc(count, sizeof(char *));
-	errno_t ret = names ? EOK : ENOMEM;
+	const char **names = calloc(count, sizeof(char *));
+	int ret = names ? EOK : ENOMEM;
 	for (size_t i = 0; i < count && ret == EOK; ++i) {
 		link_t *slink = list_nth(&hound->sinks, i);
@@ -502,5 +501,5 @@
  * identifiers with the same index are connected.
  */
-errno_t hound_list_connections(hound_t *hound, const char ***sources,
+int hound_list_connections(hound_t *hound, const char ***sources,
     const char ***sinks, size_t *size)
 {
@@ -517,5 +516,5 @@
  * @return Error code.
  */
-errno_t hound_connect(hound_t *hound, const char* source_name, const char* sink_name)
+int hound_connect(hound_t *hound, const char* source_name, const char* sink_name)
 {
 	assert(hound);
@@ -556,9 +555,9 @@
  * @return Error code.
  */
-errno_t hound_disconnect(hound_t *hound, const char* source_name, const char* sink_name)
-{
-	assert(hound);
-	fibril_mutex_lock(&hound->list_guard);
-	const errno_t ret = hound_disconnect_internal(hound, source_name, sink_name);
+int hound_disconnect(hound_t *hound, const char* source_name, const char* sink_name)
+{
+	assert(hound);
+	fibril_mutex_lock(&hound->list_guard);
+	const int ret = hound_disconnect_internal(hound, source_name, sink_name);
 	fibril_mutex_unlock(&hound->list_guard);
 	return ret;
@@ -574,5 +573,5 @@
  * This function has to be called with the list_guard lock held.
  */
-static errno_t hound_disconnect_internal(hound_t *hound, const char* source_name,
+static int hound_disconnect_internal(hound_t *hound, const char* source_name,
     const char* sink_name)
 {
Index: uspace/srv/audio/hound/hound.h
===================================================================
--- uspace/srv/audio/hound/hound.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/hound.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -65,20 +65,20 @@
 } hound_t;
 
-errno_t hound_init(hound_t *hound);
-errno_t hound_add_ctx(hound_t *hound, hound_ctx_t *ctx);
-errno_t hound_remove_ctx(hound_t *hound, hound_ctx_t *ctx);
+int hound_init(hound_t *hound);
+int hound_add_ctx(hound_t *hound, hound_ctx_t *ctx);
+int hound_remove_ctx(hound_t *hound, hound_ctx_t *ctx);
 hound_ctx_t *hound_get_ctx_by_id(hound_t *hound, hound_context_id_t id);
 
-errno_t hound_add_device(hound_t *hound, service_id_t id, const char *name);
-errno_t hound_add_source(hound_t *hound, audio_source_t *source);
-errno_t hound_add_sink(hound_t *hound, audio_sink_t *sink);
-errno_t hound_list_sources(hound_t *hound, char ***list, size_t *size);
-errno_t hound_list_sinks(hound_t *hound, char ***list, size_t *size);
-errno_t hound_list_connections(hound_t *hound, const char ***sources,
+int hound_add_device(hound_t *hound, service_id_t id, const char* name);
+int hound_add_source(hound_t *hound, audio_source_t *source);
+int hound_add_sink(hound_t *hound, audio_sink_t *sink);
+int hound_list_sources(hound_t *hound, const char ***list, size_t *size);
+int hound_list_sinks(hound_t *hound, const char ***list, size_t *size);
+int hound_list_connections(hound_t *hound, const char ***sources,
     const char ***sinks, size_t *size);
-errno_t hound_remove_source(hound_t *hound, audio_source_t *source);
-errno_t hound_remove_sink(hound_t *hound, audio_sink_t *sink);
-errno_t hound_connect(hound_t *hound, const char *source_name, const char *sink_name);
-errno_t hound_disconnect(hound_t *hound, const char *source_name, const char *sink_name);
+int hound_remove_source(hound_t *hound, audio_source_t *source);
+int hound_remove_sink(hound_t *hound, audio_sink_t *sink);
+int hound_connect(hound_t *hound, const char* source_name, const char* sink_name);
+int hound_disconnect(hound_t *hound, const char* source_name, const char* sink_name);
 
 #endif
Index: uspace/srv/audio/hound/hound_ctx.c
===================================================================
--- uspace/srv/audio/hound/hound_ctx.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/hound_ctx.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,6 +45,6 @@
 #include "log.h"
 
-static errno_t update_data(audio_source_t *source, size_t size);
-static errno_t new_data(audio_sink_t *sink);
+static int update_data(audio_source_t *source, size_t size);
+static int new_data(audio_sink_t *sink);
 
 /**
@@ -68,5 +68,5 @@
 			return NULL;
 		}
-		const errno_t ret = audio_sink_init(ctx->sink, name, ctx, NULL,
+		const int ret = audio_sink_init(ctx->sink, name, ctx, NULL,
 		    NULL, new_data, &AUDIO_FORMAT_DEFAULT);
 		if (ret != EOK) {
@@ -99,5 +99,5 @@
 			return NULL;
 		}
-		const errno_t ret = audio_source_init(ctx->source, name, ctx, NULL,
+		const int ret = audio_source_init(ctx->source, name, ctx, NULL,
 		    update_data, &AUDIO_FORMAT_DEFAULT);
 		if (ret != EOK) {
@@ -199,5 +199,5 @@
  * @return Error code.
  */
-static errno_t stream_push_data(hound_ctx_stream_t *stream, audio_data_t *adata)
+static int stream_push_data(hound_ctx_stream_t *stream, audio_data_t *adata)
 {
 	assert(stream);
@@ -216,5 +216,5 @@
 	}
 
-	const errno_t ret = audio_pipe_push(&stream->fifo, adata);
+	const int ret = audio_pipe_push(&stream->fifo, adata);
 	fibril_mutex_unlock(&stream->guard);
 	if (ret == EOK)
@@ -297,5 +297,5 @@
  * @return Error code.
  */
-errno_t hound_ctx_stream_write(hound_ctx_stream_t *stream, const void *data,
+int hound_ctx_stream_write(hound_ctx_stream_t *stream, const void *data,
     size_t size)
 {
@@ -312,5 +312,5 @@
 	}
 
-	const errno_t ret =
+	const int ret =
 	    audio_pipe_push_data(&stream->fifo, data, size, stream->format);
 	fibril_mutex_unlock(&stream->guard);
@@ -327,5 +327,5 @@
  * @return Error code.
  */
-errno_t hound_ctx_stream_read(hound_ctx_stream_t *stream, void *data, size_t size)
+int hound_ctx_stream_read(hound_ctx_stream_t *stream, void *data, size_t size)
 {
 	assert(stream);
@@ -340,12 +340,10 @@
 
 	pcm_format_silence(data, size, &stream->format);
-	const size_t ret =
+	const int ret =
 	    audio_pipe_mix_data(&stream->fifo, data, size, &stream->format);
 	fibril_mutex_unlock(&stream->guard);
-	if (ret > 0) {
+	if (ret == EOK)
 		fibril_condvar_signal(&stream->change);
-		return EOK;
-	}
-	return EEMPTY;
+	return ret;
 }
 
@@ -356,12 +354,13 @@
  * @param size Size of the @p data buffer.
  * @param format Destination data format.
- * @return Size of the destination buffer touch with stream's data.
- */
-size_t hound_ctx_stream_add_self(hound_ctx_stream_t *stream, void *data,
+ * @return Size of the destination buffer touch with stream's data,
+ *         error code on failure.
+ */
+ssize_t hound_ctx_stream_add_self(hound_ctx_stream_t *stream, void *data,
     size_t size, const pcm_format_t *f)
 {
 	assert(stream);
 	fibril_mutex_lock(&stream->guard);
-	const size_t ret = audio_pipe_mix_data(&stream->fifo, data, size, f);
+	const int ret = audio_pipe_mix_data(&stream->fifo, data, size, f);
 	fibril_condvar_signal(&stream->change);
 	fibril_mutex_unlock(&stream->guard);
@@ -391,5 +390,5 @@
  * Mixes data from all streams and pushes it to all connections.
  */
-errno_t update_data(audio_source_t *source, size_t size)
+int update_data(audio_source_t *source, size_t size)
 {
 	assert(source);
@@ -425,5 +424,5 @@
 }
 
-errno_t new_data(audio_sink_t *sink)
+int new_data(audio_sink_t *sink)
 {
 	assert(sink);
@@ -458,10 +457,13 @@
 	list_foreach(sink->connections, source_link, connection_t, conn) {
 		/* This should not trigger data update on the source */
-		connection_add_source_data(
+		const size_t copied = connection_add_source_data(
 		    conn, buffer, bsize, sink->format);
+		if (copied != bsize)
+			log_error("Copied less than advertised data, "
+			    "something is wrong");
 	}
 	/* push to all streams */
 	list_foreach(ctx->streams, link, hound_ctx_stream_t, stream) {
-		const errno_t ret = stream_push_data(stream, adata);
+		const int ret = stream_push_data(stream, adata);
 		if (ret != EOK)
 			log_error("Failed to push data to stream: %s",
Index: uspace/srv/audio/hound/hound_ctx.h
===================================================================
--- uspace/srv/audio/hound/hound_ctx.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/hound_ctx.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -69,11 +69,11 @@
 
 hound_ctx_stream_t *hound_ctx_create_stream(hound_ctx_t *ctx, int flags,
-    pcm_format_t format, size_t buffer_size);
+	pcm_format_t format, size_t buffer_size);
 void hound_ctx_destroy_stream(hound_ctx_stream_t *stream);
 
-errno_t hound_ctx_stream_write(hound_ctx_stream_t *stream, const void *buffer,
+int hound_ctx_stream_write(hound_ctx_stream_t *stream, const void *buffer,
     size_t size);
-errno_t hound_ctx_stream_read(hound_ctx_stream_t *stream, void *buffer, size_t size);
-size_t hound_ctx_stream_add_self(hound_ctx_stream_t *stream, void *data,
+int hound_ctx_stream_read(hound_ctx_stream_t *stream, void *buffer, size_t size);
+ssize_t hound_ctx_stream_add_self(hound_ctx_stream_t *stream, void *data,
     size_t size, const pcm_format_t *f);
 void hound_ctx_stream_drain(hound_ctx_stream_t *stream);
Index: uspace/srv/audio/hound/iface.c
===================================================================
--- uspace/srv/audio/hound/iface.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/iface.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 #include "log.h"
 
-static errno_t iface_add_context(void *server, hound_context_id_t *id,
+static int iface_add_context(void *server, hound_context_id_t *id,
     const char *name, bool record)
 {
@@ -55,5 +55,5 @@
 		return ENOMEM;
 
-	const errno_t ret = hound_add_ctx(server, ctx);
+	const int ret = hound_add_ctx(server, ctx);
 	if (ret != EOK)
 		hound_ctx_destroy(ctx);
@@ -63,5 +63,5 @@
 }
 
-static errno_t iface_rem_context(void *server, hound_context_id_t id)
+static int iface_rem_context(void *server, hound_context_id_t id)
 {
 	assert(server);
@@ -69,5 +69,5 @@
 	if (!ctx)
 		return EINVAL;
-	const errno_t ret = hound_remove_ctx(server, ctx);
+	const int ret = hound_remove_ctx(server, ctx);
 	if (ret == EOK) {
 		hound_ctx_destroy(ctx);
@@ -86,5 +86,5 @@
 }
 
-static errno_t iface_get_list(void *server, char ***list, size_t *size,
+static int iface_get_list(void *server, const char ***list, size_t *size,
     const char *connection, int flags)
 {
@@ -98,5 +98,5 @@
 }
 
-static errno_t iface_connect(void *server, const char *source, const char *sink)
+static int iface_connect(void *server, const char *source, const char *sink)
 {
 	log_info("%s: %p, %s -> %s", __FUNCTION__, server, source, sink);
@@ -104,5 +104,5 @@
 }
 
-static errno_t iface_disconnect(void *server, const char *source, const char *sink)
+static int iface_disconnect(void *server, const char *source, const char *sink)
 {
 	log_info("%s: %p, %s -> %s", __FUNCTION__, server, source, sink);
@@ -110,5 +110,5 @@
 }
 
-static errno_t iface_add_stream(void *server, hound_context_id_t id, int flags,
+static int iface_add_stream(void *server, hound_context_id_t id, int flags,
     pcm_format_t format, size_t size, void **data)
 {
@@ -130,5 +130,5 @@
 }
 
-static errno_t iface_rem_stream(void *server, void *stream)
+static int iface_rem_stream(void *server, void *stream)
 {
 	hound_ctx_destroy_stream(stream);
@@ -136,5 +136,5 @@
 }
 
-static errno_t iface_drain_stream(void *stream)
+static int iface_drain_stream(void *stream)
 {
 	hound_ctx_stream_drain(stream);
@@ -142,10 +142,10 @@
 }
 
-static errno_t iface_stream_data_read(void *stream, void *buffer, size_t size)
+static int iface_stream_data_read(void *stream, void *buffer, size_t size)
 {
 	return hound_ctx_stream_read(stream, buffer, size);
 }
 
-static errno_t iface_stream_data_write(void *stream, const void *buffer, size_t size)
+static int iface_stream_data_write(void *stream, const void *buffer, size_t size)
 {
 	return hound_ctx_stream_write(stream, buffer, size);
Index: uspace/srv/audio/hound/main.c
===================================================================
--- uspace/srv/audio/hound/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/audio/hound/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -57,5 +57,5 @@
 static hound_t hound;
 
-static errno_t device_callback(service_id_t id, const char *name)
+static int device_callback(service_id_t id, const char *name)
 {
 	return hound_add_device(&hound, id, name);
@@ -76,5 +76,5 @@
 	}
 
-	errno_t ret = hound_init(&hound);
+	int ret = hound_init(&hound);
 	if (ret != EOK) {
 		log_fatal("Failed to initialize hound structure: %s",
